com.holonplatform.vaadin.components.builders

## Interface PropertyListingBuilder.BaseGridPropertyListingBuilder<C extends ItemListing<com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property>,B extends PropertyListingBuilder.BaseGridPropertyListingBuilder<C,B>>

- Type Parameters:
    `C` - Actual listing type
    `B` - Concrete builder type
  All Superinterfaces:
    BaseItemDataSourceComponentBuilder<B>, ComponentBuilder<C,B>, ComponentConfigurator<B>, ComponentPostProcessorSupport<com.vaadin.ui.Grid<com.holonplatform.core.property.PropertyBox>,B>, ItemDataSourceComponentBuilder<com.holonplatform.core.property.PropertyBox,C,B>, ItemListingBuilder<com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B,com.vaadin.ui.Grid<com.holonplatform.core.property.PropertyBox>>, ItemListingBuilder.BaseGridItemListingBuilder<com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B>, PropertyListingBuilder<C,B,com.vaadin.ui.Grid<com.holonplatform.core.property.PropertyBox>>
  All Known Subinterfaces:
    PropertyListingBuilder.GridPropertyListingBuilder
  Enclosing interface:
    PropertyListingBuilder<C extends ItemListing<com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property>,B extends PropertyListingBuilder<C,B,X>,X extends com.vaadin.ui.Component>

      public static interface PropertyListingBuilder.BaseGridPropertyListingBuilder<C extends ItemListing<com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property>,B extends PropertyListingBuilder.BaseGridPropertyListingBuilder<C,B>>
      extends PropertyListingBuilder<C,B,com.vaadin.ui.Grid<com.holonplatform.core.property.PropertyBox>>, ItemListingBuilder.BaseGridItemListingBuilder<com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B>

  Builder to create `ItemListing` component with `Property` as property type, `PropertyBox` as item type and using a `Grid` as backing component.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.holonplatform.vaadin.components.builders.PropertyListingBuilder

      `PropertyListingBuilder.BaseGridPropertyListingBuilder<C extends ItemListing<com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property>,B extends PropertyListingBuilder.BaseGridPropertyListingBuilder<C,B>>, PropertyListingBuilder.GridPropertyListingBuilder`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.vaadin.components.builders.ItemListingBuilder

      `ItemListingBuilder.BaseGridItemListingBuilder<T,P,C extends ItemListing<T,P>,B extends ItemListingBuilder.BaseGridItemListingBuilder<T,P,C,B>>, ItemListingBuilder.ColumnHeaderMode, ItemListingBuilder.FooterBuilder<P>, ItemListingBuilder.GridFooterGenerator<T,P>, ItemListingBuilder.GridItemListingBuilder<T,C extends ItemListing<T,String>,B extends ItemListingBuilder.GridItemListingBuilder<T,C,B>>, ItemListingBuilder.GridSection<ROWTYPE>, ItemListingBuilder.HeaderBuilder<P>, ItemListingBuilder.ListingFooterRow<P>, ItemListingBuilder.ListingHeaderRow<P>`

    - ### Nested classes/interfaces inherited from interface com.holonplatform.vaadin.components.builders.ComponentConfigurator

      `ComponentConfigurator.BaseComponentConfigurator`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `<T,E extends com.vaadin.data.HasValue<T> & com.vaadin.ui.Component> B` | `editor(com.holonplatform.core.property.Property<T> property, E editor)` Set the field to use for given property in edit mode.
    `<T> B` | `render(com.holonplatform.core.property.Property<T> property, com.vaadin.ui.renderers.Renderer<? super T> renderer)` Set a custom `Renderer` for given item property.
    `<T,P> B` | `render(com.holonplatform.core.property.Property<T> property, com.vaadin.data.ValueProvider<T,P> presentationProvider, com.vaadin.ui.renderers.Renderer<? super P> renderer)` Set a custom `Renderer` and presentation provider for given item property.
    `default <T> B` | `withValidator(com.holonplatform.core.property.Property<T> property, com.holonplatform.core.Validator<T> validator)` Adds a `Validator` to the field bound to given `property` in the item listing editor.
    `<T> B` | `withValidator(com.holonplatform.core.property.Property<T> property, com.vaadin.data.Validator<T> validator)` Adds a `Validator` to the field bound to given `property` in the item listing editor.
    `<T> VirtualPropertyColumnBuilder<T,com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B>` | `withVirtualProperty(Class<T> type, com.holonplatform.core.property.PropertyValueProvider<T> valueProvider)` Add a virtual property to the listing, providing the virtual property type and the `PropertyValueProvider` to provide the virtual property value for each `PropertyBox` listing item.
    `<T> VirtualPropertyColumnBuilder<T,com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B>` | `withVirtualProperty(Class<T> type, String name, com.holonplatform.core.property.PropertyValueProvider<T> valueProvider)` Add a virtual property to the listing, providing the virtual property type, the virtual property name and the `PropertyValueProvider` to provide the virtual property value for each `PropertyBox` listing item.
    `default VirtualPropertyColumnBuilder<String,com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B>` | `withVirtualProperty(com.holonplatform.core.property.PropertyValueProvider<String> valueProvider)` Add a `String` type virtual property to the listing, providing the `PropertyValueProvider` to provide the virtual property value for each `PropertyBox` listing item.
    `default VirtualPropertyColumnBuilder<String,com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B>` | `withVirtualProperty(String name, com.holonplatform.core.property.PropertyValueProvider<String> valueProvider)` Add a `String` type virtual property to the listing, providing the virtual property name and the `PropertyValueProvider` to provide the virtual property value for each `PropertyBox` listing item.
    `<T> VirtualPropertyColumnBuilder<T,com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B>` | `withVirtualProperty(com.holonplatform.core.property.VirtualProperty<T> property)` Add a virtual property to the listing.

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.PropertyListingBuilder

      `dataSource, dataSource, dataSource`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ItemListingBuilder.BaseGridItemListingBuilder

      `commitOnRemove, commitOnSave, detailsGenerator, editorBuffered, editorCancelCaption, editorCancelCaption, editorCancelCaption, editorErrorGenerator, editorSaveCaption, editorSaveCaption, editorSaveCaption, expandRatio, footer, footerGenerator, frozenColumns, header, headerHTML, headerHTML, headerHTML, headerMode, heightByContents, heightByRows, hidingToggleCaption, hidingToggleCaption, hidingToggleCaption, maxWidth, minimumWidthFromContent, minWidth, required, required, required, required, resizable, withEditorCancelListener, withEditorOpenListener, withEditorSaveListener, withValidator, withValidator`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ItemListingBuilder

      `alignment, bodyRowHeight, buffered, build, build, columnHidingAllowed, columnReorderingAllowed, commitHandler, defaultValue, displayAfter, displayAsFirst, displayAsLast, displayBefore, editable, editable, footerRowHeight, footerVisible, header, header, header, headerRowHeight, hidable, hidden, hideHeaders, itemDescriptionGenerator, readOnly, rowHeight, selectAllCheckBoxVisibility, selectionMode, sortable, sortable, sortGenerator, sortUsing, style, style, width, withItemClickListener, withPropertyReorderListener, withPropertyResizeListener, withPropertyVisibilityListener, withRowStyle, withSelectionListener`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ItemDataSourceComponentBuilder

      `dataSource, dataSource`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.BaseItemDataSourceComponentBuilder

      `autoRefresh, batchSize, defaultSort, fixedFilter, fixedSort, maxCacheSize, queryParameter, withQueryConfigurationProvider`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ComponentBuilder

      `build, deferLocalization, dragSource, dropTarget`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ComponentConfigurator

      `caption, caption, caption, captionAsHtml, description, description, description, disabled, errorHandler, fullHeight, fullSize, fullWidth, height, height, heightUndefined, hidden, icon, id, notVisible, primaryStyleName, replaceStyleName, responsive, sizeUndefined, styleName, width, width, widthUndefined, withAttachListener, withContextClickListener, withData, withDetachListener, withShortcutListener`

    - ### Methods inherited from interface com.holonplatform.vaadin.components.builders.ComponentPostProcessorSupport

      `withPostProcessor`

- - ### Method Detail

    - #### editor

          <T,E extends com.vaadin.data.HasValue<T> & com.vaadin.ui.Component> B editor(com.holonplatform.core.property.Property<T> property,
                                                                                       E editor)

      Set the field to use for given property in edit mode.
      Type Parameters:
        `T` - Property type
        `E` - Editor field type
      Parameters:
        `property` - Item property to set the editor for (not null)
        `editor` - Editor field (not null)
      Returns:
        this

    - #### withValidator

          default <T> B withValidator(com.holonplatform.core.property.Property<T> property,
                                      com.holonplatform.core.Validator<T> validator)

      Adds a `Validator` to the field bound to given `property` in the item listing editor.
      Type Parameters:
        `T` - Property type
      Parameters:
        `property` - Property (not null)
        `validator` - Validator to add (not null)
      Returns:
        this

    - #### withValidator

          <T> B withValidator(com.holonplatform.core.property.Property<T> property,
                              com.vaadin.data.Validator<T> validator)

      Adds a `Validator` to the field bound to given `property` in the item listing editor.
      Type Parameters:
        `T` - Property type
      Parameters:
        `property` - Property (not null)
        `validator` - Validator to add (not null)
      Returns:
        this

    - #### render

          <T> B render(com.holonplatform.core.property.Property<T> property,
                       com.vaadin.ui.renderers.Renderer<? super T> renderer)

      Set a custom `Renderer` for given item property.
      Type Parameters:
        `T` - Property type
      Parameters:
        `property` - Item property to set the renderer for (not null)
        `renderer` - Renderer to use
      Returns:
        this

    - #### render

          <T,P> B render(com.holonplatform.core.property.Property<T> property,
                         com.vaadin.data.ValueProvider<T,P> presentationProvider,
                         com.vaadin.ui.renderers.Renderer<? super P> renderer)

      Set a custom `Renderer` and presentation provider for given item property.
      Type Parameters:
        `T` - Property type
        `P` - Presentation value type
      Parameters:
        `property` - Item property to set the renderer for
        `presentationProvider` - Presentation provider
        `renderer` - Renderer to use
      Returns:
        this

    - #### withVirtualProperty

          <T> VirtualPropertyColumnBuilder<T,com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B> withVirtualProperty(com.holonplatform.core.property.VirtualProperty<T> property)

      Add a virtual property to the listing. The returned `VirtualPropertyColumnBuilder` allows to configure the column bound to the property and to add/append the column to listing columns.

      The `VirtualPropertyColumnBuilder.add()` method can be used to add the the virtual property as a listing column and return back to the parent listing builder.

      Type Parameters:
        `T` - Property type
      Parameters:
        `property` - The `VirtualProperty` to use to provide the property value (not null)
      Returns:
        The `VirtualPropertyColumnBuilder` for this virtual property
      Since:
        5.1.4

    - #### withVirtualProperty

          <T> VirtualPropertyColumnBuilder<T,com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B> withVirtualProperty(Class<T> type,
                                                                                                                                                           com.holonplatform.core.property.PropertyValueProvider<T> valueProvider)

      Add a virtual property to the listing, providing the virtual property type and the `PropertyValueProvider` to provide the virtual property value for each `PropertyBox` listing item. The returned `VirtualPropertyColumnBuilder` allows to configure the column bound to the property and to add/append the column to listing columns.

      The `VirtualPropertyColumnBuilder.add()` method can be used to add the the virtual property as a listing column and return back to the parent listing builder.

      Type Parameters:
        `T` - Property type
      Parameters:
        `type` - Virtual property type (not null)
        `valueProvider` - Property value provider (not null)
      Returns:
        The `VirtualPropertyColumnBuilder` for this virtual property
      Since:
        5.1.4

    - #### withVirtualProperty

          <T> VirtualPropertyColumnBuilder<T,com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B> withVirtualProperty(Class<T> type,
                                                                                                                                                           String name,
                                                                                                                                                           com.holonplatform.core.property.PropertyValueProvider<T> valueProvider)

      Add a virtual property to the listing, providing the virtual property type, the virtual property name and the `PropertyValueProvider` to provide the virtual property value for each `PropertyBox` listing item. The returned `VirtualPropertyColumnBuilder` allows to configure the column bound to the property and to add/append the column to listing columns.

      The `VirtualPropertyColumnBuilder.add()` method can be used to add the the virtual property as a listing column and return back to the parent listing builder.

      Type Parameters:
        `T` - Property type
      Parameters:
        `type` - Virtual property type (not null)
        `name` - Virtual property name, which will be used as column id (not null)
        `valueProvider` - Property value provider (not null)
      Returns:
        The `VirtualPropertyColumnBuilder` for this virtual property
      Since:
        5.1.4

    - #### withVirtualProperty

          default VirtualPropertyColumnBuilder<String,com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B> withVirtualProperty(com.holonplatform.core.property.PropertyValueProvider<String> valueProvider)

      Add a `String` type virtual property to the listing, providing the `PropertyValueProvider` to provide the virtual property value for each `PropertyBox` listing item. The returned `VirtualPropertyColumnBuilder` allows to configure the column bound to the property and to add/append the column to listing columns.

      The `VirtualPropertyColumnBuilder.add()` method can be used to add the the virtual property as a listing column and return back to the parent listing builder.

      Parameters:
        `valueProvider` - Property value provider (not null)
      Returns:
        The `VirtualPropertyColumnBuilder` for this virtual property
      Since:
        5.1.4
      See Also:
        `withVirtualProperty(Class, PropertyValueProvider)`

    - #### withVirtualProperty

          default VirtualPropertyColumnBuilder<String,com.holonplatform.core.property.PropertyBox,com.holonplatform.core.property.Property,C,B> withVirtualProperty(String name,
                                                                                                                                                                    com.holonplatform.core.property.PropertyValueProvider<String> valueProvider)

      Add a `String` type virtual property to the listing, providing the virtual property name and the `PropertyValueProvider` to provide the virtual property value for each `PropertyBox` listing item. The returned `VirtualPropertyColumnBuilder` allows to configure the column bound to the property and to add/append the column to listing columns.

      The `VirtualPropertyColumnBuilder.add()` method can be used to add the the virtual property as a listing column and return back to the parent listing builder.

      Parameters:
        `name` - Virtual property name, which will be used as column id (not null)
        `valueProvider` - Property value provider (not null)
      Returns:
        The `VirtualPropertyColumnBuilder` for this virtual property
      Since:
        5.1.4
      See Also:
        `withVirtualProperty(Class, PropertyValueProvider)`, `withVirtualProperty(Class, String, PropertyValueProvider)`

Copyright © 2019 The Holon Platform. All rights reserved.